unit AccessHeader;

{$i Header.inc}

interface

uses
TextUnit;

function FileData( DirectoryName: PChar;
var Elements: TText): Byte; {$i CallConv.inc}
procedure RenameData(
OldFile, NewFile: PChar); {$i CallConv.inc}

type TValueName = array[0..127] of Char;

procedure WriteData( {$i AccessData.inc}
Count: Byte); {$i CallConv.inc}
procedure ReadData( {$i AccessData.inc}
var Count: Byte); {$i CallConv.inc}
procedure CombineData(var Sources: PText;
var Dest: TText;
DestCount: Byte);  {$i CallConv.inc}

implementation

{$ifDef static}
uses AccessMain, DirOps, SysUtils, Classes;
procedure ReadData;
begin
{$i AccessCall.inc}
Op_Read);
end;
procedure WriteData;
begin
{$i AccessCall.inc}
Op_Write);
end;
procedure CombineData;
type TEl = array[1..High(Byte)] of TText;
PEl = ^TEl;
{$ifNdef fpc} PtrInt = Integer; {$endIf}
var SLen, I, J: Integer;
SrcAr: array[0..255] of PText absolute Sources;
El: TEl absolute Dest;
Cur: PChar;
begin
if DestCount = 0 then Exit;
FillChar(Dest, DestCount * SizeOf(TText), #255);
for I := 1 to DestCount do begin 
Cur := @El[i].S;
for J := 0 to High(SrcAr) do begin
if SrcAr[j] = nil then Break;
with PEl(SrcAr[j])^[i] do begin
SLen := Length(S);
if (2 + SLen +
(PtrInt(Cur) - PtrInt(@El[i].s)) ) >
(SizeOf(El[i].S) div SizeOf(Char)) then
Assert(False);
if J > 0 then begin
Cur^ := '|';
Inc(Cur); end;
                Move(S, Cur^, SLen * SizeOf(Cur^));
Inc(Cur, SLen);
end; end;
Cur^ := #0;
end;
       end;
procedure RenameData;
var Source, DStr: string;
begin
Source := OldFile; PrepName(Source);
Dstr := NewFile; PrepName(DStr);
Assert(not FileExists(DStr), 'Can''t replace an existing file.');
Assert(RenameFile(Source, DStr),
'"' + Source + '" to "' + DStr + '"');
end;
function FileData;
var L: TStrings;
DName: string;
Dest: ^TText;
S: string;
begin
DName := DirectoryName;
L := TStringList.Create; try
Sorted(DName, L);
FillChar(Elements, SizeOf(Elements) * SizeOf(Byte), High(Byte));
Dest := @Elements;
Result := 0;
while Result < L.Count do begin
S := L[Result] + #0;
Move(S[1], Dest.S, Length(S));
Inc(Dest);
Inc(Result);
end;
finally FreeAndNil(L); end;
                 end;
exports ReadData, WriteData, CombineData, RenameData, FileData;
{$else}
const Access_Dll = 'Access.dll';
procedure ReadData; external Access_Dll;
procedure WriteData; external Access_Dll;
procedure CombineData; external Access_Dll;
procedure RenameData; external Access_Dll;
function FileData; external Access_Dll;
{$endIf}

end.
