unit BuildHeader;

{$i Header.inc}

interface

uses FontInfo, ControlUnit, CanvasInfo, TextUnit, CallbackUnit, RestoreInfo;

procedure AllowFramesToAccessTheStack; {$i CallConv.inc}
procedure SetCleanup(
Cleanup: TCallback); {$i CallConv.inc}
procedure BuildForm( Caption: PChar; Width, Height: Word;
 var Controls: TControl; ControlCount: Word;
FontInfo: PFontInfo;
FormType: TFormType); {$i CallConv.inc}

implementation

{$ifDef static}
uses FormBuild, TermUnit, Classes, SysUtils;
procedure BuildForm;
var F: TFormBuild;
begin
CheckThread;
try
F :=  TFormBuild.Create( @Controls, ControlCount) ; try
F.FontInfo := FontInfo;
F.Caption := Caption;
F.Width := Width;
F.Height := Height;
F.FormType := FormType;
F.Display;
finally FreeAndNil(F); end;
except on E: Exception do
Term(E.ClassName + ': ' + E.Message);
end;
end;
procedure AllowFramesToAccessTheStack;
begin
FrameStackEnabled := True;
end;
procedure SetCleanup;
begin
CheckThread;
FormBuild.Cleanup := Cleanup;
end;
exports BuiLDform, SetCleanup, AllowFramesToAccessTheStack;
{$else}
const Build_Lib = 'Build.dll';
procedure SetCleanup; external Build_Lib;
procedure AllowFramesToAccessTheStack; external Build_Lib;
procedure BuildForm; external Build_Lib;
{$endIf}

end.
