unit ControlUnit;

{$i Header.inc}

interface

uses CanvasInfo, TextUnit, CallbackUnit;

const
Bit_Hidden = 1;
Bit_Disabled = 2;
Bit_Keyboard = 4;
Bit_ReadOnly = Bit_Keyboard;
Bit_Video = 8;
Bit_Checked = 4;
Bit_Close = 128;
Bit_Valid = 64;
Bit_Print = 32;
Bit_Centred = 4;
Bit_Enter = 4;
Bit_Escape = 8;
Bit_Insert = 16;
Bit_Delete = 32;
type
TModel = (
Model_Edit,
Model_Button,
Model_CheckBox,
Model_ComboBox,
Model_ListBox,
Model_Panel,
Model_GroupBox,
Model_Label,
Model_SpeedButton,
Model_PaintBox,
Model_Bevel,
Model_StringGrid);

                           type
PText = ^TText;
TCursor = (Cursor_Normal, Cursor_Link, Cursor_Canvas);
THIDType = (HID_KeyDown, HID_KeyUp, HID_MouseDown, HID_MouseUp, HID_MouseMove, Hid_MouseEnter, Hid_MouseLeave);
THID = packed record
HIDType: THIDType;
VirtualKey: Word;
MousePixelX, MousePixelY: Word;
end;
PHID = ^THID;
LTRB_Dimension = Low(SmallInt)..-1;
const
WH_EnforceBorder = High(Word);
LT_Adjacent = High(SmallInt);
LTRB_Parallel = 0;
type
TControl = packed record
Model: TModel;
State: Byte;
Active: TText;
Lines: PText;
LineCount, SelectedLine: Byte;
Callback: TCallback;
L, T, R, B: SmallInt;
CanvasInfo: PCanvasInfo;
HID: PHID;
Cursor: TCursor;
          end;
TFormType = (Form_Window_Main,
Form_Window_Full, Form_Window_Dialog,
Form_Frame_Main, Form_Frame_Dialog);


implementation

end.
