unit FileActionUnit;

interface

uses
Windows,
// CoInitialize is called at startup in ComObj:
ComObj, ActiveX,
ShellAPI,
SysUtils, Classes;

function FileAction(FileName, Parameters: string; Visible: Boolean): Boolean; overload;
function FileAction(FileName: string): Boolean; overload;

var FA_Max_Millis: Cardinal = Infinite;

implementation

function ProcessSS(FN, P: string; Vis, WaitFor: Boolean): Boolean;
var SI: TStartupInfo;
PI: TProcessInformation;
Cmd: string;
Code: Cardinal;
begin
Cmd := FN;
if Pos(' ', CMD) > 0 then
Cmd := '"' + Cmd + '"';
Cmd := Cmd + ' ' + P + #0#0;
FillChar(PI, SizeOf(PI), 0);
FillChar(SI, SizeOf(SI), 0);
with SI do begin
cb := SizeOf(SI);
if not Vis then begin
wShowWindow := Sw_Hide;
dwFlags := STARTF_USESHOWWINDOW;
end; end;
Result := CreateProcess(nil, @Cmd[1],
          nil, nil,
False, 0, nil,
nil, SI,
PI);
if Result then begin
if  WaitFor then
if WaitForSingleObject(PI.hProcess, FA_Max_Millis) =
WAIT_TIMEOUT then begin
TerminateProcess(PI.hProcess, 1);
Result := False;
end else begin
Code := 1;
GetExitCodeProcess(PI.hProcess, Code);
Result := Code = 0;
end;
CloseHandle(PI.hProcess);
CloseHandle(PI.hThread);
end; end;



function FileActionSS(Action: string; FileName: string; Parameters: string; ShowCMD: Integer): Boolean;
begin
//Assert(S_ok = CoInitializeEx(nil, COINIT_APARTMENTTHREADED or COINIT_DISABLE_OLE1DDE)); try
Result := 32 <  ShellExecute(
0, PChar(Action), PChar(FileName), PChar(Parameters), nil, ShowCMD);
//finally CoUninitialize; end;
end;

function FileAction(FileName, Parameters: string; Visible: Boolean): Boolean;
const ShowCom: array [Boolean] of Integer = (
SW_Hide, SW_ShowNormal);
var IncExe: Boolean;
begin
IncExe := SameText(ExtractFileExt(FileName), '.exe');
if IncExe or
(Pos(PathDelim, FileName) = 0) then
Result := ProcessSS(FileName, Parameters, Visible, not IncExe)
else Result := FileActionSS('open', FileName, Parameters, ShowCom[Visible]);
end;

function FileAction(FileName: string): Boolean;
begin
Result := FileActionSS('print', FileName, '', SW_SHOWMINNOACTIVE);
end;

end.
