unit FileUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TemplateUnit, ExtCtrls, Buttons, StdCtrls;

type
  TFileForm = class(TTemplate)
    Logo: TImage;
    DontBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    NumberOne: TLabel;
    FirstLab: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure DontBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
procedure ChildHide;
  public
    { Public declarations }
  end;

var
  FileForm: TFileForm;

implementation

uses DiscardUnit;

{$R *.dfm}

procedure TFileForm.FormCreate(Sender: TObject);
begin
  inherited;
SetLength(Columns, 1);
with Columns[0] do begin
Left := 0;
Right := (Logo.Left * 2) + Logo.Width;
Initial := clActiveCaption;
Final := clInactiveCaption;
   end;
end;

procedure TFileForm.DontBtnClick(Sender: TObject);
begin
if DiscardForm.ShowModal = MrAbort  then Abort;
ChildHide;
end;

procedure TFileForm.ChildHide;
begin
FOrmStyle := fsNormal;
Hide;
end;

procedure TFileForm.SaveBtnClick(Sender: TObject);
begin
  inherited;
ChildHide;
end;

procedure TFileForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
Action := caNone;
if not DOntBtn.Enabled then begin
SaveBtn.Click;
Exit; end;
case CoolMB('Do you want to save changes to the following file?'
+ SLineBreak + SlineBreak +
Caption, 'Close File',
Mb_IconQuestion or
MB_YesNoCancel)
of
Id_yes: SaveBtn.Click;
Id_No: DontBtn.Click;
end;
end;

end.
