unit Home;
// This unit must be separate to Profile, as it needs to run cross-platform.

interface

function GetHome: string;

implementation

{$ifDef MsWindows}
uses Profile, ShFolder;
{$endIf}

const Env = 'HOME';

function GetHome;
begin
        {$ifDef MsWindows}
Result := GetProfile(
CSIDL_COMMON_DOCUMENTS);
{$else}
Result := GetEnvironmentVariable(Env);
Assert(Result <> '', 'Please set your ' + Env + ' environment variable: it is currently blank.');
Result := IncludeTrailingPathDelimiter(Result);
{$endIf}
end;
end.
