unit LogIt;

interface

uses Windows, SysUtils, Classes, Profile, ShFolder, XmlConst, SessInfo, Forms, FileActionUnit;

procedure Silently(O: TObject;
Section: Widestring = ''; Quit: Boolean = True; Message: string = '');

implementation

function Modified: TSystemTime;
var FT: TFileTime;
begin
with TFileStream.Create(ParamStr(0), fmOpenRead or fmShareDenyNone) do try
Assert(GetFileTime(Handle, nil, nil, @FT));
finally Free; end;
FileTimeToSystemTime(FT, Result);
end;

    function FormatTime(UTC: TSystemTime): string;
var DT: TDateTime;
begin
DT := SystemTimeToDateTime(UTC);
DT := DT + (2 / HoursPerDay);
Result := DateTimeToStr(DT) + ' SAST';
end;

const Form = '.xml';

function ExeErr: string;
begin
Result := ExtractFilePath(
ParamStr(0)) + 'Last Error'
+ Form;
      end;

function DocErr: string;
begin
Result := GetProfile(
                     Csidl_Personal) + 'Last ' +
ChangeFileExt(
ExtractFileName(
ParamStr(0)), '') +
' Error' + Form;
end;

procedure Silently;
var F: Text;
procedure V(Name, Data: string);
begin
WriteLn(F, UTF8Encode(ValueStart(Name, 1, Data)));
end;
var Sample: TSystemTime;
const AccStr: array[Boolean] of string = (
'Cordoned', 'Pandemonium');
var FileName: string;
procedure SetupFile(AName: string);
begin
FileName := AName;
Assign(F, AName);
Rewrite(F);
end;
begin
GetSystemTime(Sample);
try
try  SetupFile(ExeErr);
except on EInOutError do SetupFile(DocErr);
end; 
try
WriteLn(F, XmlUTF8);
WriteLn(F, '<' + O.ClassName + '>');
if O is Exception then
Message := (O as Exception).Message;
V('Message', Message);
if Section = '' then
Section := ExtractFileName(
ChangeFileExt(
ParamStr(0), ''));
V('Section', Section);
V('Executable', ParamStr(0));
V('Modified', FormatTime(Modified));
V('Working', GetCurrentDir);
V('Access', AccStr[HasRights]);
V('User', GetUserName);
                                    V('Computer', GetComputerName);
V('Occurred', FormatTime(Sample));
WriteLn(F, '</' + O.ClassName + '>');
finally Close(F); end;
if (GetCurrentThreadID = MainThreadID) and
((Screen.FormCount > 0) or
Assigned(Application.MainForm)) then
FileAction(FileName, '', True);
except on EInOutError do; end;
if not Quit then Exit;
TerminateProcess(
GetCurrentProcess, 1);
Halt(1);
end;

end.
