unit LoginUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CentroidUnit, StdCtrls, Buttons, ExtCtrls, DateUtils;

type
TPasswordChar = '1'..'9';
TPassword = array[1..3] of TPasswordChar;
{$i Login.inc}
  TLoginForm = class(TCentroid)
    SevenBtn: TSpeedButton;
    AdminBtn: TSpeedButton;
    HashEdit: TEdit;
    ClearTim: TTimer;
    SecTim: TTimer;
    StatusLab: TLabel;
    WebsiteLab: TLabel;
    procedure AdminBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ClearTimTimer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure SecTimTimer(Sender: TObject);
    procedure SevenBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
FMemory: string;
  public
    { Public declarations }
Users: TUsers;
  end;

var
  LoginForm: TLoginForm;

implementation

uses ActionPOS9, TablesUnit;

{$R *.dfm}

procedure TLoginForm.AdminBtnClick(Sender: TObject);
begin
  inherited;
ParentForm.SwapVectors;
Hide;
end;

procedure TLoginForm.FormShow(Sender: TObject);
begin
  inherited;
ClearTim.OnTimer(nil);
SecTim.OnTimer(nil);
SecTim.Enabled := True;
end;

procedure TLoginForm.ClearTimTimer(Sender: TObject);
begin
  inherited;
Finalize(FMemory);
HashEdit.Clear;
end;

procedure TLoginForm.FormKeyPress(Sender: TObject; var Key: Char);
var I: Integer;
begin
  inherited;
case Key of
Low(TPasswordChar)..
High(TPasswordChar): ;
else Exit; end;
FMemory := FMemory + Key;
Key := #0;
with HashEdit do
Text := Text + '#';
ClearTim.Enabled := False;
if Length(FMemory) < SizeOf(TPassword) then begin
ClearTim.Enabled := True;
Exit; end;
with Users do
for I := 1 to Count do
with              Elements[i] do
if FMemory = Password then
with TablesForm do begin
User := Name;
Show;
Self.Hide;
Exit;
end;
ClearTim.OnTimer(nil);
BadCall('Invalid User Password');
end;

procedure TLoginForm.FormCreate(Sender: TObject);
var X, Y: 0..2;
Gap: Integer;
begin
  inherited;
Gap := AdminBtn.Left div 2;
for Y := Low(Y) to High(Y) do
for X := Low(X) to High(X) do
with TSpeedButton.Create(Self) do begin
Parent := Self;
BoundsRect := SevenBtn.BoundsRect;
OnClick := SevenBtn.OnClick;
Font.Assign(SevenBtn.Font);
Left := Left + ((Width + Gap) * X);
Top := Top + ((Height + Gap) * Y);
Caption := IntToStr(7 - (Y * 3) + X);
Name := 'AutoBtn' + StripCap(Caption);
end;
SevenBtn.Hide;
end;

procedure TLoginForm.SevenBtnMouseDown;
var K: Char;
begin
  inherited;
K := (Sender as TSpeedButton).Caption[1];
OnKeyPress(nil, K);
end;

procedure TLoginForm.FormHide(Sender: TObject);
begin
  inherited;
ClearTim.Enabled := False;
SecTim.Enabled := False;
end;

procedure TLoginForm.SecTimTimer(Sender: TObject);
var H, M: Byte;
begin
  inherited;
H := HourOf(Now);
M := MinuteOf(Now);
StatusLab.Caption :=
Format('SALES  :  %-2d : %-2d', [H, M]);
end;

end.
