unit PersistHeader;

{$i Header.inc}

interface

uses
CallbackUnit, TextUnit;

type
Table_Column = array[0..19] of Char;
TOperation = (
Op_List,
Op_Add,
Op_Edit,
Op_Delete);

function GetCleanup: TCallback; {$i CallConv.inc}
procedure PersistData(
const Table: Table_Column;
Operation: TOperation;
const Column: Table_Column;
                          var Data: TText;
var Number: Byte); {$i CallConv.inc}

implementation

{$ifDef static}
uses TermUnit, LockStates, LockProcs, Table, SysUtils, Classes;
function GetCleanup;
begin
if LockState = Lock_Single then
Term('First GetCleanup should not be after first PersistData.');
if LockState = Lock_Undecided then begin
 CheckThread;
LockState := Lock_Multi;
end;
Result := Unlock;
end;
procedure persistData;
begin
if LockState = Lock_Undecided then
LockState := Lock_Single;
if LockState = Lock_Multi then Lock;
try
                                  with TTable.Create(Table) do try
//case Operation of
//end;
finally Free; end;
except on E: Exception do
Term(E.ClassName + ': ' +
E.Message); end;
end;
exports PersistData, GetCleanup;
{$else}
function getCleanup; external Persist_Lib;
procedure PersistData; external Persist_Lib;
{$endIf}

end.
