unit Profile;

interface

uses
Windows, SHFolder, SysUtils;

function GetProfile(CSIDL: Integer): string;
function TempProfile: string;
function GenerateProfile: string;

implementation

procedure OKDir(var Result: string; Raw: PChar);
begin
Result := Raw;
Assert(Result <> '');
Result := IncludeTrailingPathDelimiter(Result);
if not DirectoryExists(Result) then
ForceDirectories(Result);
end;

function GetProfile;
var
Buf: array[0..MAX_PATH] of Char;
RawPChar: PChar;
begin
FillChar(Buf, SizeOf(Buf), 0);
RawPChar := @Buf;
Assert(SHGetFolderPath(0, CSIDL, 0, 0, RawPChar) = 0);
OKDir(Result, RawPChar);
end;

function TempProfile;
var
Buf: array[0..MAX_Path] of Char;
begin
FillChar(Buf, SizeOf(Buf), 0);
GetTempPath(MAX_Path, @Buf);
OKDir(Result, @Buf);
end;

function GenerateProfile;
var
G: TGuid;
begin
Assert(CreateGUID(G) = 0);
Result := TempProfile
+ GUIDToString(G);
end;

end.
