unit SalesUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CentroidUnit, Buttons, Math, ExtCtrls;

type
{$i Sales.inc}
TFastLine = array[0..3] of string;
TTotalBlock = array[0..6] of TFastLine;
PTotalBlock = ^TTotalBlock;
  TSalesForm = class(TCentroid)
    CatBtn: TSpeedButton;
    SelPaint: TPaintBox;
    IteBtn: TSpeedButton;
    DiscountBtn: TSpeedButton;
    ConfirmBtn: TSpeedButton;
    DiscardBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CatBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; DummyX, DummyY: Integer);
    procedure CatBtnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure IteBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CatBtnClick(Sender: TObject);
    procedure SelPaintMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SelPaintPaint(Sender: TObject);
    procedure ConfirmBtnClick(Sender: TObject);
    procedure DiscardBtnClick(Sender: TObject);
  private
    { Private declarations }
Pending: array of ShortString;
LastCategory: string;
Fast: array of TFastLine;
PreTotal, FastIndex: Integer;
procedure TotalBlock(var Dest: TTotalBlock);
function LoadCat(Cap: string): Boolean;
function TransID: PCardinal;
function NewID: Cardinal; // Sets the ID for the new receipt.
procedure ChangeSel(NewIndex: Integer);
procedure AddFastInstruct(A, B, C, D: string);
procedure RemoveStyles(Sign: ShortInt);
procedure DelNega;
function WordWrap(S: string; Con: TControl): string;
  public
    { Public declarations }
Table: Byte;
Sales: array[0..Pred(High(Word) div SizeOf(TSale))] of TSale;
  end;

var
  SalesForm: TSalesForm;

implementation

uses ItemsUnit, ReceiptsUnit, TablesUnit, LoginUnit, DiscardUnit;

{$R *.dfm}

procedure TSalesForm.FormCreate(Sender: TObject);
begin
  inherited;
                         ElementSize := SizeOf(TSale);
Persistent[SizeOf(Sales)] := @Sales;
                                                      WindowState := wsMaximized;
SetLength(Columns, 2);
with Columns[0] do begin
Left := 0;
Right := (CatBtn.Left * 2) + CatBtn.Width;
// These must be the inverse of their correspondents, as Gradient might equal Caption:
Initial := clGradientActiveCaption;
Final := clGradientInactiveCaption;
end;
with Columns[1] do begin
Left := Columns[0].Right;
Right := SelPaint.Left;
// These must just be the default values:
Initial := clInactiveCaption;
Final := clActiveCaption;
end; end;

procedure TSalesForm.FormShow(Sender: TObject);
function Index(S: string): Integer;
var I: Integer;
begin
Result := -1;
for I := 0 to Pred(ControlCount) do
with Controls[i] as TSpeedButton do
if Tag > 0 then
if S = StripCap(Caption) then begin
Result := I;
Break; end;
end;
type TQty = record
Q: Byte;
N: string;
P: Integer;
end;
var Qty: array of TQty;
procedure AddToQty(Item: TItem);
var I: Integer;
begin
               for I := 0 to High(Qty) do
if Qty[i].N = Item.Name then begin
Inc(qty[i].Q);
Exit; end;
SetLength(Qty, Succ(Length(Qty)));
with Qty[High(Qty)] do begin
Q := 1;
N := Item.Name;
P := Item.cents;
end; end;
var I, CatCounter: Integer;
begin
  inherited;
if TransID^ = 0 then
TransID^ := NewID;
Pending := nil;
Fast := nil;
AddFastInstruct('', '', '', DateToStr(Now));
AddFastInstruct('', '', '', TimeToStr(Now));
AddFastInstruct('-', '', '', '');
AddFastInstruct('Name', '', 'Qty', 'Price');
                                 AddFastInstruct('', '', '', '');
for I := 0 to High(Sales) do
with Sales[i] do
if Trans = TransID^ then
AddToQty(ItemsForm.Items.Elements[ItemOffset]);
                                      for I := 0 to High(Qty) do
with Qty[i] do
AddFastInstruct(N, '', IntToStr(Q), CentsToStr(P));
if Length(Qty) > 0 then
AddFastInstruct('', '', '', '');
CatCounter := 0;
with ItemsForm.Items do
for I := 1 to Count do
if -1 = Index(Elements[i].Category) then
if not (cfExtras in Elements[i].CatFlags) then
with TSpeedButton.Create(nil) do begin
Parent := Self;
BoundsRect := CatBtn.BoundsRect;
                                Caption := WordWrap(Elements[i].Category, CatBtn);
Top := Top +
(CatCounter * (Top + Height));
Inc(CatCounter);
Tag := CatCounter;
OnClick := CatBtn.OnClick;
OnMouseMove := CatBtn.OnMouseMove;
OnMouseDown := CatBtn.OnMouseDown;
if LastCategory = StripCap(Caption) then begin
LastCategory := '';
Click;
end;
           end;
end;

function TSalesForm.WordWrap(S: string; Con: TControl): string;
var M, P: Integer;
begin
UniqueString(S);
if Canvas.TextWidth(S + ' ') <= Con.Width then Exit;
for M := 0 to Pred(Length(S) div 2) do begin
P := (Length(S) div 2) + M + 1;
                             P := EnsureRange(P, 1, Length(S));
if S[p] = ' ' then begin
Insert(sLineBreak, S, P);
Break; end;
end;
Result := s;
end;

function TSalesForm.LoadCat;
var Idex: Byte;
I: Integer;
X, Y: Word;
CatTag: Integer;
begin
CatTag := 0;
Cap := StripCap(Cap);
Result :=  LastCategory <> Cap ;
if not Result then Exit;
DelNega;
for I := 0 to Pred(ControlCount) do
if Controls[i] is TSpeedButton then
with Controls[i] as TSpeedButton do
if StripCap(Caption) = Cap then
if Tag > 0 then
CatTag := Tag;
RemoveStyles(1);
Idex := 1;
for Y := 0 to Pred(
(ClientHeight - (IteBtn.Top * 2)) div IteBtn.Height) do
for X := 0 to Pred(
(((Columns[1].Right - Columns[1].Left) - (IteBtn.Top * 2)) div IteBtn.Width)) do
with ItemsForm.Items do
if Idex <= Count then
if Elements[idex].Category = StripCap(Cap) then
with TSpeedButton.Create(nil) do begin
Parent := Self;
BoundsRect := IteBtn.BoundsRect;
Caption := WordWrap(Elements[idex].Name, IteBtn);
Left := Left + (X * (Top + Width));
Top := Top + (Y * (Top + Height));
Tag := -CatTag;
OnMouseDown := IteBtn.OnMouseDown;
end;
LastCategory := Cap;
end;

procedure TSalesForm.DelNega;
var I: Integer;
Deleted: Boolean;
begin
repeat
Deleted := False;
for I := 0 to Pred(ControlCOunt) do
if COntrols[i] is TSpeedButton then
if Controls[i].Tag < 0 then begin
Deleted := true;
Controls[i].Free;
Break; end;
until not Deleted;
end;

procedure TSalesForm.RemoveStyles(Sign: ShortInt);
var I: Word;
begin
            for I := 0 to Pred(COntrolCOunt) do
if COntrols[i] is TSpeedButton then
if (COntrols[i].Tag * Sign) > 0 then
with (Controls[i] as TSpeedButton).Font do
                                  Style := [];
end;

procedure TSalesForm.CatBtnMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited;
(Sender as TSpeedButton).OnMouseDown(
Sender, mbLeft, [], 0, 0); 
end;

procedure TSalesForm.IteBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Snd: TSpeedButton absolute Sender;
Prefix: ShortString;
begin
  inherited;
RemoveStyles(-1);
Prefix := StripCap(Snd.Caption);
SetLength(Pending, Succ(Length(Pending)));
Pending[High(Pending)] := Prefix;
with ItemsForm do
AddFastInstruct(Prefix, '', '', CentsToStr(PItem(
ByPrefix[Prefix, Succ(Length(Prefix)), SizeOf(TItem)])^.Cents));
                                      Snd.font.Style := [fsUnderLine];
end;

procedure TSalesForm.CatBtnClick(Sender: TObject);
begin
  inherited;
with Sender as TSpeedButton do
OnMouseDown(Sender, mbLeft, [], 0, 0);
end;

procedure TSalesForm.AddFastInstruct(A, B, C, D: string);
begin
SetLength(Fast, PreTotal);
SetLength(Fast, Succ(Length(Fast)));
Fast[High(Fast)][0] := A;
Fast[High(Fast)][1] := B;
Fast[High(Fast)][2] := C;
Fast[High(Fast)][3] := D;
ChangeSel(High(Fast));
PreTotal := Length(Fast);
                          SetLength(Fast, Length(Fast) + High(TTotalBlock) + 1);
TotalBlock(PTotalBlock(@Fast[PreTotal-1])^);
end;

procedure TSalesForm.SelPaintMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var FastIndex: Integer;
LU: Integer;
begin
  inherited;
with SelPaint do begin
LU := Canvas.TextHeight('H');
Dec(Y, LU div 2);
FastIndex := Y div LU;
end;
ChangeSel(FastIndex);
end;

procedure TSalesForm.ChangeSel;
begin
FastIndex := NewIndex;
SelPaint.Invalidate;
end;

procedure TSalesForm.SelPaintPaint(Sender: TObject);
var I: Byte;
J: 0..3;
LU: Integer;
procedure DrawLine;
var S: string;
C: Word;
begin
C := 0;
repeat
Inc(C);
S := StringOfChar('-', C);
until SelPaint.Canvas.TextWidth(S) >
(SelPaint.Width - LU);
Delete(S, 1, 1);
with SelPaint, SelPaint.Canvas do
TextOut((Width div 2) -
(TextWidth(S) div 2),
(LU div 2) + (LU * I), S);
end;
var X: Integer;
begin
  inherited;
X := -100;
with SelPaint do begin
Canvas.Font.Assign(Font);
LU := Canvas.TextHeight('H');
for I := 0 to High(Fast) do
for J := 0 to High(J) do begin
if Fast[i, 0] = '-' then begin
DrawLine;
Continue; end;
case J of
0, 1: X := LU div 2;
2, 3: X := Width - (LU div 2);
end;
case J of
1: Inc(X, Canvas.TextWidth('Table 00'));
2: Dec(X, Canvas.TextWidth('Tot 0000.00'));
end;
case J of
1, 2, 3: Dec(X, Canvas.TextWidth(Fast[I, J]));
end;
if FastIndex = I then
Canvas.Font.Color := clBlue;
            Canvas.TextOut(X,
(I * LU) + (LU div 2), Fast[i, J]);
if FastIndex = I then
Canvas.Font.Color := clBlack;
end; end;
end;

function TSalesForm.NewID: Cardinal;
var
A: PReceipt;
LR: TReceipt;
begin
Result := 0;
with ReceiptsForm do begin
A := PReceipt(ByPrefix[Result, SizeOf(Result), 0]);
FillChar(LR, SizeOf(LR), 0);
Dec(A);
Result := A.ID;
Inc(Result);
A := @LR;
A^.ID := Result;
A^.waitron := TablesForm.User;
AppendElement(A^);
end;
end;

function TSalesForm.TransID: PCardinal;
begin
with TablesForm do
Result := @Tables.Elements[Table];
end;

procedure TSalesForm.ConfirmBtnClick(Sender: TObject);
var I: Integer;
S: TSale;
P: ShortString;
O: Cardinal;
begin
  inherited;
S.Trans := TransID^;
with ItemsForm do
                for I := 0 to High(Pending) do begin
P := Pending[i];
O := Cardinal(ByPrefix[P, 1 + Length(P), 0]);
Dec(O, Cardinal(@Items));
O := O div SizeOf(TItem);
S.ItemOffset := O;
Self.AppendElement(S);
                  end;
LoginForm.Show;
Hide;
end;

procedure TSalesForm.TotalBlock(var Dest: TTotalBlock);
begin

end;

procedure TSalesForm.DiscardBtnClick(Sender: TObject);
begin
if DiscardForm.ShowModal = mrAbort then Exit;
LoginForm.Show;
Hide;
end;

procedure TSalesForm.CatBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; DummyX, DummyY: Integer);
begin

with Sender as TSpeedButton do
if  LoadCat(Caption) then
Font.Style := [fsUnderline];
end;

end.
