unit Startup;

interface

uses Windows, Registry, Classes, SysUtils;

function StartupThis: Boolean;
procedure StartupOther(FileName: string; Install: Boolean);

implementation

type TRegOper = (Reg_Check, Reg_Write, Reg_Delete);

procedure Reg(Oper: TRegOper; FileName: string);
var R: TRegistry;
procedure OK(K: string; C: Boolean = True);
begin
if Oper = Reg_Check  then begin
if R.OpenKeyReadOnly(K) then Exit;
                      end else if R.OpenKey(K, C) then Exit;
Assert(False, 'Failed to open key: ' + K);
end;
var ValName: string;
begin
ValName := ChangeFileExt(
ExtractFileName(FileName), '')
+ ' Startup';
R :=  TRegistry.Create; try
R.RootKey := Hkey_Local_Machine;
OK('software', False);
OK('microsoft');
OK('windows');
OK('currentversion');
OK('run');
case Oper of
Reg_Check: Assert(R.ValueExists(ValName), 'Need to create value.');
Reg_Write:  R.WriteString(ValName,
'"' + FileName + '"');
Reg_Delete: if R.ValueExists(ValName) then
R.DeleteValue(ValName);
end; finally FreeAndNil(R); end;
end;

function StartupThis;
begin
Result := False;
try Reg(Reg_Check, ParamStr(0));
except
Reg(Reg_Write, ParamStr(0));
Result := True; end;
                                        end;

procedure StartupOther;
const Modes: array[Boolean] of TRegOper =
(Reg_Delete, Reg_Write);
begin
Reg(Modes[Install], FileName);
end;

end.
