unit TablesUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CentroidUnit, StdCtrls, Buttons;

type
{$i Tables.inc}
 TTablesForm = class(TCentroid)
    SelectLab: TLabel;
    NoChgBtn: TSpeedButton;
    OneBtn: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure NoChgBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure OneBtnClick(Sender: TObject);
  private
    { Private declarations }
KeyBuf: string;
  public
    { Public declarations }
Tables: TTables;
User: string;
  end;

var
  TablesForm: TTablesForm;

implementation

uses LoginUnit, SalesUnit, ReceiptsUnit;

{$R *.dfm}

procedure TTablesForm.FormShow(Sender: TObject);
var X, Y: Word;
Counter: Byte;
type TTableState = (tsIdle, tsSame, tsOther);
function TableState: TTableState;
var ID: Cardinal;
begin
ID := Tables.Elements[Counter];
if ID = 0 then begin
Result := tsIdle;
Exit; end;
with PReceipt(ReceiptsForm.ByPrefix[
ID, SizeOf(ID), 0])^ do
if Waitron = User then
Result := tsSame
else Result := tsOther;
end;
const DoubleZero: array[0..1] of Char = ('0', '0');
begin
  inherited;
SelectLab.Caption :=
Format('SELECT TABLE, %s', [User]);
KeyBuf := '';
Counter := 0;
for Y := 0 to Pred(
(ClientHeight - OneBtn.Top - (OneBtn.Left div 2)) div
(OneBtn.Height + (OneBtn.Left div 2))) do
for X := 0 to Pred(
(ClientWIdth - OneBtn.Left - (OneBtn.Left div 2)) div
(OneBtn.Width + (OneBtn.Left div 2))) do
                                      with TSpeedButton.Create(nil) do begin
Parent := Self;
Inc(Counter);
if Tables.Count > 9 then
Caption := FormatFloat(DoubleZero, Counter)
else Caption := IntToStr(Counter);
Font.Assign(OneBtn.Font);
case TableState of
tsOther: Enabled := False;
tsSame: with Font do
Style := Style + [fsUnderline];
end;
BoundsRect := OneBtn.BoundsRect;
Top := Top + (Y * (Height + (Left div 2)));
Left := Left + (X * (Width + (Left div 2)));
OnClick := OneBtn.OnClick;
                                 if Counter = Tables.Count then Exit;
end;
   end;

procedure TTablesForm.NoChgBtnClick(Sender: TObject);
begin
  inherited;
LoginForm.Show;
Hide;
end;

procedure TTablesForm.FormCreate(Sender: TObject);
begin
  inherited;
Persistent[SizeOf(Tables)] := @Tables;
end;

procedure TTablesForm.FormKeyPress(Sender: TObject; var Key: Char);
var I: Byte;
begin
  inherited;
case Key of
'0'..'9': begin
KeyBuf := KeyBuf + Key;
for I := 0 to Pred(ControlCount) do
if Controls[i] is TSpeedButton then
with Controls[i] as TSpeedButton do
if Pos(StripCap(Caption), KeyBuf) > 0 then
if Enabled then Click;
end;
Chr(VK_Escape): NoChgBtn.Click;
else KeyBuf := '';
Exit end;
Key := #0;
end;

procedure TTablesForm.OneBtnClick(Sender: TObject);
begin
  inherited;
with Sender as TSpeedButton do
SalesForm.Table := StrToInt(
StripCap(Caption));
SalesForm.Show;
Hide;
end;

end.
